#include "hwgui.ch"

#define WM_USER                        1024    // 0x0400

#define WM_CAP_START WM_USER

#define WM_CAP_FILE_SAVEDIBA (WM_CAP_START+ 25)

#define WS_CHILD     0x40000000
#define WS_VISIBLE   0x10000000

THREAD STATIC hWnd, lConnect:=.F.

*---------------------------------------------------------------------------------------
FUNCTION Main
*---------------------------------------------------------------------------------------
LOCAL oFontBtn
LOCAL oFont := Nil
LOCAL nColor
LOCAL cDirFoto := Hb_Dirbase() + [FOTOS\]

   SET DELETE ON
   
   SET DATE BRITISH
   
   cDriverName:=""

   PREPARE FONT oFontBtn NAME "MS Sans Serif" WIDTH 0 HEIGHT -12

   INIT WINDOW Form_Main MAIN TITLE "WebCam" SIZE 640, 480 ON INIT {||CameraSource( @cDriverName, Form_Main )} 
   

   MENU OF Form_Main
      MENU TITLE "&WebCam"
         MENUITEM "&Ligar Camera"            ACTION {||PreviewCamera( cDriverName, @hWnd, Form_Main )}
         MENUITEM "Configurar WebCam"        ACTION {||SetupVideo( hWnd ) }
         MENUITEM "&Bater Foto"              ACTION {||SaveToJPG( hWnd, cDirFoto )}
         MENUITEM "Redimensionar"            ACTION {||Redimensionar( cDirFoto )}
         SEPARATOR
         MENUITEM "&Sair"                    ACTION {||CapDriverDisconnect(hWnd), hwg_EndWindow()}
      ENDMENU

       MENU TITLE "&Ajuda"
         MENUITEM "&Sobre" ACTION hwg_MsgInfo( Hwg_Version(1) )
      ENDMENU
   ENDMENU
   
   @ 10,0 IMAGE Image_1 SHOW "IMAGE" SIZE 640, 480 
   
   Form_Main:Activate()

RETURN Nil

*------------------------------------------------------------------------------*
FUNCTION CameraSource( cDriverName, Form_Main )
*------------------------------------------------------------------------------*
cDriverName    := Space(128)
cDriverVersion := Space(128)

   FOR I := 0 TO 20
      IF capGetDriverDescription( i, @cDriverName, 128, @cDriverVersion, 128 )
         //hwg_MsgInfo( cDriverName )
         EXIT
      ENDIF
   NEXT
   
   Form_Main:Caption := "Driver da webcam : " + cDriverName

RETURN cDriverName

*------------------------------------------------------------------------------*
FUNCTION PreviewCamera( cDriverName, hWnd, Form_Main )
*------------------------------------------------------------------------------*
LOCAL i := 0
LOCAL nMaxAttempt := 10

   hWnd := capCreateCaptureWindow( "WebCam", hb_bitOr( WS_CHILD, WS_VISIBLE ), ;
           Form_Main:Image_1:nLeft, Form_Main:Image_1:nTop, Form_Main:Image_1:nWidth, Form_Main:Image_1:nHeight, ;
           Form_Main:handle, 1)

  DO WHILE ! lConnect .Or. ++i > nMaxAttempt
      lConnect := LigaWebCam( hWnd, i )
  ENDDO
   
  IF lConnect
     // set the preview scale
     capPreviewScale( hWnd, .T. ) //.T.
     // set the preview rate (ms)
     capPreviewRate( hWnd, 60 ) //30
     // start previewing the image
     capPreview( hWnd, .T. )

     //CapOverlay( hWnd, .T. )
     
   ELSE
     // error connecting to video source
     hwg_DestroyWindow( hWnd )
     hWnd := 0
  ENDIF

RETURN lConnect

*-----------------------------------------------------------------------------*
FUNCTION SaveToJPG( hWnd, cDirFoto )
*-----------------------------------------------------------------------------*
LOCAL cBmp := cDirFoto + "TESTE.BMP", cJpg := cDirFoto + "TESTE.JPG", cPng := cDirFoto + "TESTE.PNG"

  Hb_Default(@cDirFoto, Hb_Dirbase())

  fi_Initialise()

  CapFileSaveDIB( hWnd, cBmp )
  
  //hwg_SendMessage( hWnd, WM_CAP_FILE_SAVEDIBA, 0, cBmp )

  im := Fi_Load( FIF_BMP, cBmp, BMP_DEFAULT )
  
  Fi_Save( FIF_JPEG, im, cJpg, JPEG_DEFAULT )
	
  Fi_Save( FIF_PNG , im, cPng, PNG_DEFAULT  )

  fi_DeInitialise()

  //CapFileSetCaptureFile( hWnd, "TESTE.AVI" )
  
  //Capture( hWnd )

  //Ferase( cBmp ) // Remove temporary file

RETURN Nil

FUNCTION WaitThread( nThread ) 

   DO WHILE .T.
      IF hb_ThreadWait( nThread, 0.1, .T. ) == 1 
         EXIT
      ENDIF
      hwg_DoEvents()
   ENDDO
   
RETURN Nil  
      
FUNCTION Redimensionar( cDirFoto )
LOCAL cBmp := cDirFoto + "TESTE.BMP", cJpg := cDirFoto + "TESTE.JPG", cPng := cDirFoto + "TESTE.PNG"

   fi_Initialise()

   * Carrega a imagem
 
   image := fi_Load( FIF_PNG, cPng, PNG_DEFAULT )
  
   * Pega o tamanho da imagem
   
   width   := fi_GetWidth( image )
   
   height  := fi_GetHeight( image )

   * Ou atribui outra resuluo

   width  := 300
  
   height := 200

   * Redimensiona a imagem
   
   * Dividindo a imagem original por 2 
   rescale := fi_Rescale( image, width / 2, height / 2, FILTER_BICUBIC )
  
   * Ou tamanho atribudo
  
   rescale := fi_Rescale( image, width, height, FILTER_BICUBIC )


   * Salva a imagem com ootra dimenso

   Fi_Save( FIF_PNG, rescale, cDirFoto + "rescale.png", PNG_DEFAULT )
  
   fi_DeInitialise()

RETURN Nil

#pragma BEGINDUMP

#include <hbapi.h>
#include <windows.h>
#include "vfw.h"

HB_FUNC( TESTE )

{
        
  BITMAPINFO szBitmapInfo;
capGetVideoFormat((HWND) hb_parnl(1), &szBitmapInfo, sizeof(BITMAPINFO));
szBitmapInfo.bmiHeader.biBitCount = 24;
szBitmapInfo.bmiHeader.biWidth = 320;
szBitmapInfo.bmiHeader.biHeight = 200;
szBitmapInfo.bmiHeader.biSizeImage = 0; // or *4
capSetVideoFormat((HWND) hb_parnl(1), &szBitmapInfo, sizeof(szBitmapInfo));


//SendMessage((HWND) hb_parnl(1), WM_CAP_SET_VIDEOFORMAT, 300, BITMAPINFO);

}


HB_FUNC( CAPGETDRIVERDESCRIPTION )
{
 TCHAR lpszName[128];
 int iName = hb_parni(3);
 TCHAR lpszVer[128];
 int iVer = hb_parni(5);
 BOOL bRet;

 bRet = capGetDriverDescription( (WORD) hb_parnl(1), lpszName, iName, lpszVer, iVer );

 hb_storc( lpszName, 2 );
 hb_storc( lpszVer, 4 );

 hb_retl( bRet );
}

HB_FUNC( CAPCREATECAPTUREWINDOW )
{
 hb_retnl( (LONG) capCreateCaptureWindowA( (LPCSTR) hb_parc(1),
                                          (DWORD) hb_parnl(2),
                                          hb_parni(3), hb_parni(4),
                                          hb_parni(5), hb_parni(6),
                                          (HWND) hb_parnl(7),
                                          hb_parni(8) ) );
}

HB_FUNC( CAPDRIVERCONNECT )
{
 hb_retl( capDriverConnect( (HWND) hb_parnl(1), hb_parni(2) ) );
}

HB_FUNC( CAPDRIVERDISCONNECT )
{
 hb_retl( capDriverDisconnect( (HWND) hb_parnl(1) ) );
}

HB_FUNC( CAPPREVIEWRATE )
{
 hb_retl( capPreviewRate( (HWND) hb_parnl(1), (WORD) hb_parnl(2) ) );
}

HB_FUNC( CAPPREVIEWSCALE )
{
 hb_retl( capPreviewScale( (HWND) hb_parnl(1), hb_parl(2) ) );
}

HB_FUNC( CAPPREVIEW )
{
 hb_retl( capPreview( (HWND) hb_parnl(1), hb_parl(2) ) );
}

HB_FUNC( CAPCAPTURESEQUENCE )
{
 hb_retl( capCaptureSequence( (HWND) hb_parnl(1) ) );
}

HB_FUNC( CAPFILESAVEAS )
{
 hb_retl( capFileSaveAs( (HWND) hb_parnl(1), hb_parc(2) ) );
}

HB_FUNC( CAPFILESAVEDIB )
{
 hb_retl( capFileSaveDIB( (HWND) hb_parnl(1), hb_parc(2) ) );
}

HB_FUNC( CAPDLGVIDEODISPLAY )
{
   hb_retl( capDlgVideoDisplay( (HWND) hb_parnl( 1 ) ) );
}

HB_FUNC( SETUPVIDEO )
{
   CAPDRIVERCAPS CapDriverCaps;
   CAPSTATUS CapStatus;

   capDriverGetCaps( (HWND) hb_parnl( 1 ), &CapDriverCaps, sizeof (CAPDRIVERCAPS));

   // Video source dialog box.
   if (CapDriverCaps.fHasDlgVideoSource)
       capDlgVideoSource( (HWND) hb_parnl( 1 ) );

   // Video format dialog box.
   if (CapDriverCaps.fHasDlgVideoFormat)
      {
       capDlgVideoFormat( (HWND) hb_parnl( 1 ) );

       // Are there new image dimensions?
       capGetStatus( (HWND) hb_parnl( 1 ), &CapStatus, sizeof (CAPSTATUS));
       // New Dimensions of Window
       SetWindowPos( (HWND) hb_parnl( 1 ), NULL, 0, 0, CapStatus.uiImageWidth,
                      CapStatus.uiImageHeight, SWP_NOZORDER | SWP_NOMOVE);

       // If so, notify the parent of a size change.
      }

    // Video display dialog box.
    if (CapDriverCaps.fHasDlgVideoDisplay)
        capDlgVideoDisplay( (HWND) hb_parnl( 1 ) );
}

HB_FUNC( CAPTURE )
{

  hb_retl( SendMessage ( (HWND) hb_parnl( 1 ), WM_CAP_SEQUENCE, 0, 0L) );

}

HB_FUNC( CAPTURESTOP )
{
   hb_retl( SendMessage ( (HWND) hb_parnl( 1 ), WM_CAP_STOP, 0, 0L) );
}

HB_FUNC( CAPOVERLAY )
{
   CAPDRIVERCAPS CapDrvCaps;
   capDriverGetCaps( (HWND) hb_parnl( 1 ), &CapDrvCaps, sizeof (CAPDRIVERCAPS));

   if (CapDrvCaps.fHasOverlay)
       hb_retl( capOverlay( (HWND) hb_parnl( 1 ), hb_parl( 2 ) ) );
   else
       hb_retl( FALSE );
}

HB_FUNC( CAPFILESETCAPTUREFILE )
{
  BOOL fResult;
  fResult = capFileSetCaptureFile( (HWND)hb_parnl(1), (LPSTR) hb_parc(2) );
  // preallocate a file of 5 MB.
  capFileAlloc( (HWND) hb_parnl(1), (1024L * 1024L * 5));

  hb_retl( fResult );
}

HB_FUNC( CAPSETVIDEOFORMAT )
{
   hb_retl( capSetVideoFormat( (HWND) hb_parnl(1), hb_parc(2), hb_parc(3) ) );
}

HB_FUNC( LIGAWEBCAM )
{
 hb_retl( SendMessage( (HWND) hb_parnl(1), WM_CAP_DRIVER_CONNECT, hb_parni(2), 0));
}

HB_FUNC( LOADLIBRARY )
{
   hb_retnl( (LONG) LoadLibraryA( (LPCSTR) hb_parc( 1 ) ) ) ;
}

HB_FUNC( FREELIBRARY )
{
   hb_retl( FreeLibrary( (HMODULE) hb_parnl( 1 ) ) ) ;
}

HB_FUNC( GETPROCADDRESS )
{
  ULONG dwProcAddr;
  char  cFuncName[MAX_PATH];

    if ((dwProcAddr = (ULONG) GetProcAddress( (HMODULE) hb_parnl(1), 
                                              HB_ISCHAR( 2 ) ? (LPCSTR) hb_parc(2) : 
                                              (LPCSTR) MAKELONG((WORD) hb_parni(2), 0) ) ) == 0 )
    {
       if ( HB_ISCHAR( 2 ) )
       {
            // try forced ANSI flavour ?
           strcpy(cFuncName, hb_parc(2));
           strcat(cFuncName, "A");            
           dwProcAddr = (ULONG) GetProcAddress((HMODULE) hb_parnl(1), cFuncName);
       }
    }

    hb_retnl( dwProcAddr );

}
#pragma ENDDUMP
